package gonganxitong

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/ctx"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type event struct {
	Table
	user    user
	command command
	service service
	order   string `data:"93"`
	role    string `data:"creator"`
}

func (s event) List(m *ice.Message, arg ...string) {
	s.Tables(m, s.user, s.command, s.service).FieldsWithCreatedAT(m, s,
		model.USER_AVATAR, model.USER_NAME, model.INFO,
		s.Key(s, model.CITY_NAME), s.Key(s, model.STREET_NAME), s.Key(s, model.PLACE_NAME),
		model.SERVICE_NAME,
	)
	if len(arg) == 1 {
		s.Select(m, model.PLACE_UID, arg[0]).Action()
	} else if len(arg) == 2 {
		s.SelectDetail(m, model.PLACE_UID, arg[0], s.Key(s, model.UID), arg[1])
	} else {
		return
	}
	s.DisplayBase(m, "")
}

func init() { ice.TeamCtxCmd(event{Table: newTable()}) }

func (s event) Record(m *ice.Message, info string, arg ...string) {
	m.Cmd(s.Prefix(m, s), s.Create, m.OptionSimple(model.COMMAND_UID, model.PLACE_UID, model.USER_UID), model.INFO, info,
		m.OptionSimple(model.CITY_NAME, model.STREET_NAME, model.PLACE_NAME), model.OPERATE, m.ActionKey(), ctx.ARGS, kit.Join(arg, ","))
}
