package yuehaoxitong

import (
	"shylinux.com/x/ice"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/yuehaoxitong/model"
)

type reception struct {
	Table
	create string `name:"create name*" role:"leader"`
	rename string `name:"rename name*" role:"leader"`
	remove string `name:"remove" role:"leader"`
}

func (s reception) Create(m *ice.Message, arg ...string) {
	s.Table.Create(m, append(arg, m.OptionSimple(model.QUEUE_UID)...)...)
	s.RecordEventWithName(m, "")
}
func (s reception) Remove(m *ice.Message, arg ...string) {
	s.Table.Delete(m, m.OptionSimple(model.QUEUE_UID, model.UID)...)
	s.RecordEventWithName(m, "")
}
func (s reception) Rename(m *ice.Message, arg ...string) {
	s.Table.Rename(m, m.OptionSimple(model.QUEUE_UID, model.UID)...)
	s.RecordEventWithName(m, "")
}
func (s reception) List(m *ice.Message, arg ...string) {
	s.Table.Fields(m, model.UID, model.NAME, model.CREATED_AT)
	if len(arg) == 0 {
		if m.Option(model.QUEUE_UID) != "" {
			s.Table.Select(m, m.OptionSimple(model.QUEUE_UID)...)
		}
	} else if len(arg) == 1 {
		s.Table.Select(m, model.QUEUE_UID, arg[0])
		kit.If(!m.IsErr() && m.Length() == 0, func() { m.EchoInfoButton("") })
	} else if len(arg) == 2 {
		s.Table.SelectDetail(m, model.QUEUE_UID, arg[0], model.UID, arg[1])
	}
	m.PushAction(s.Rename, s.Remove)
}

func init() { ice.TeamCtxCmd(reception{}) }
